/*
	Copyright 2009, 2010 Barrett Technology <support@barrett.com>

	This file is part of libbarrett.

	This version of libbarrett is free software: you can redistribute it
	and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation, either version 3 of the
	License, or (at your option) any later version.

	This version of libbarrett is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this version of libbarrett.  If not, see
	<http://www.gnu.org/licenses/>.

	Further, non-binding information about licensing is available at:
	<http://wiki.barrett.com/libbarrett/wiki/LicenseNotes>
*/

/** Includes all members of the barrett::log namespace.
 *
 * @file log.h
 * @date Jan 4, 2010
 * @author Dan Cody
 * @see barrett::log
 */

/** @namespace barrett::log
 *
 * Provides high-level facilities to write binary data to disk from a realtime task.
 */


#ifndef BARRETT_LOG_H_
#define BARRETT_LOG_H_


#include <barrett/log/reader.h>
#include <barrett/log/writer.h>
#include <barrett/log/real_time_writer.h>


#endif /* BARRETT_LOG_H_ */
