/*
	Copyright 2009, 2010 Barrett Technology <support@barrett.com>

	This file is part of libbarrett.

	This version of libbarrett is free software: you can redistribute it
	and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation, either version 3 of the
	License, or (at your option) any later version.

	This version of libbarrett is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this version of libbarrett.  If not, see
	<http://www.gnu.org/licenses/>.

	Further, non-binding information about licensing is available at:
	<http://wiki.barrett.com/libbarrett/wiki/LicenseNotes>
*/

/** Includes all members of the barrett::math namespace.
 *
 * @file math.h
 * @date Dec 23, 2009
 * @author Dan Cody
 * @see barrett::math
 */

/** @namespace barrett::math
 *
 * Provides an interface to linear-algebra libraries and implementations of
 * basic robot control algorithms.
 */


#ifndef BARRETT_MATH_H_
#define BARRETT_MATH_H_


#include <barrett/math/matrix.h>
#include <barrett/math/utils.h>

#include <barrett/math/first_order_filter.h>

#include <barrett/math/spline.h>
#include <barrett/math/trapezoidal_velocity_profile.h>

#include <barrett/math/kinematics.h>
#include <barrett/math/dynamics.h>


#endif /* BARRETT_MATH_H_ */
